## linphone 5.3.105

=== CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

cmake_minimum_required(VERSION 3.22)

project(LibLinphone VERSION 5.3.0 LANGUAGES C CXX)


set(LINPHONE_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
set(LINPHONE_MINOR_VERSION ${PROJECT_VERSION_MINOR})
set(LINPHONE_MICRO_VERSION ${PROJECT_VERSION_PATCH})
set(LINPHONE_VERSION ${PROJECT_VERSION})
set(LINPHONE_SO_VERSION "10") #incremented for 4.4.0 release.

file(GLOB LINPHONE_PO_FILES RELATIVE "${CMAKE_CURRENT_LIST_DIR}/po" "${CMAKE_CURRENT_LIST_DIR}/po/*.po")
string(REGEX REPLACE "([a-zA-Z_]+)\\.po" "\\1" LINPHONE_ALL_LANGS_LIST "${LINPHONE_PO_FILES}")
string(REPLACE ";" " " LINPHONE_ALL_LANGS "${LINPHONE_ALL_LANGS_LIST}")

include(CMakeDependentOption)
include(cmake/Tools.cmake)

option(ENABLE_ADVANCED_IM "Enable advanced instant messaging such as group chat." YES)
option(ENABLE_CONSOLE_UI "Turn on or off compilation of console interface." OFF)
option(ENABLE_CSHARP_WRAPPER "Build the C# wrapper for Liblinphone." OFF)
cmake_dependent_option(ENABLE_CSHARP_WRAPPER_TESTER "Build the C# wrapper tester for Liblinphone." NO "ENABLE_CSHARP_WRAPPER" NO)
option(ENABLE_CXX_WRAPPER "Build the C++ wrapper for Liblinphone." YES)
option(ENABLE_DB_STORAGE "Enable database storage." YES)
option(ENABLE_FLEXIAPI "Enable the FlexiAPI support for Liblinphone." YES)
option(ENABLE_SWIFT_WRAPPER "Build the swift wrapper sources for Liblinphone." OFF)
option(ENABLE_SWIFT_WRAPPER_COMPILATION "Compile and package the swift wrapper framework from the built sources." OFF)
mark_as_advanced(ENABLE_SWIFT_WRAPPER_COMPILATION) # To depreciate the option
option(ENABLE_SWIFT_DOC "Build the doc for swift module of Liblinphone." OFF)
option(ENABLE_DAEMON "Enable the linphone daemon interface." YES)
option(ENABLE_DATE "Use build date in internal version number." NO)
option(ENABLE_DEBUG_LOGS "Turn on or off debug level logs." NO)
option(ENABLE_DOC "Enable API documentation generation." NO)
option(ENABLE_JAVA_WRAPPER "Build the Java wrapper for Liblinphone." OFF)
option(ENABLE_JAVADOC "Add a target to generate documentation for Java API" NO)
option(ENABLE_JPEG "Enable JPEG support for QRCode file generation" YES)
option(ENABLE_LIME_X3DH "Enable LIMEv2 and X3DH encryption protocol." YES)
option(ENABLE_LDAP "Enable LDAP support." NO)
option(ENABLE_RELATIVE_PREFIX "Find resources relatively to the installation directory." NO)
option(ENABLE_STRICT "Build with strict compile options." YES)
option(ENABLE_TOOLS "Turn on or off compilation of tools." YES)
option(ENABLE_TUNNEL "Turn on compilation of tunnel support." NO)
option(ENABLE_TUTORIALS "Enable compilation of tutorials." YES)
option(ENABLE_UNIT_TESTS "Enable compilation of unit tests." YES)
option(ENABLE_VCARD "Turn on compilation of vcard4 support." YES)
option(ENABLE_VIDEO "Build with video support." YES)
option(ENABLE_ASSETS "Package sound assets." YES)
option(ENABLE_PACKAGE_SOURCE "Create 'package_source' target for source archive making" OFF)
option(ENABLE_SQLITE "Build with sqlite support" YES)
option(ENABLE_XML2 "Build with libxml2 support - for presence feature mainly" YES)
option(ENABLE_EXAMPLE_PLUGIN "Enable build of the example plugin" NO)
option(ENABLE_EKT_SERVER_PLUGIN "Enable build of the EKT encryption plugin" NO)

option(ENABLE_SRTP "Build with the SRTP transport support." YES)
cmake_dependent_option(ENABLE_ZRTP "Build with ZRTP support." YES "ENABLE_SRTP" NO)
cmake_dependent_option(ENABLE_GOCLEAR "Build with ZRTP GoClear message support (RFC 6189 - section 5.11)." YES "ENABLE_ZRTP" NO)
cmake_dependent_option(ENABLE_QRCODE "Enable QRCode support" YES "ENABLE_VIDEO" NO)


set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_EXTENSIONS NO)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release")
endif()
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
	add_definitions("-DDEBUG")
endif()

set(LINPHONE_LIBS_FOR_TOOLS liblinphone)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(CheckSymbolExists)
include(CheckLibraryExists)
include(CMakePushCheckState)
include(GNUInstallDirs)
include(CheckCXXCompilerFlag)

check_symbol_exists(getifaddrs "sys/types.h;ifaddrs.h" HAVE_GETIFADDRS)

check_library_exists("dl" "dlopen" "" HAVE_DLOPEN)

if(NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
endif()

# find_package should be invoked here to check for libraries - however do NOT
# call include_directories here (see below)
if(ENABLE_VCARD)
	find_package(BelCard 5.3.0 REQUIRED)
	add_definitions(-DVCARD_ENABLED)
endif()

find_package(BelleSIP 5.3.0 REQUIRED)
find_package(Mediastreamer2 5.3.0 REQUIRED)
find_package(Ortp 5.3.0 REQUIRED)
find_package(BCToolbox 5.3.0 REQUIRED OPTIONAL_COMPONENTS tester)
find_package(Belr 5.3.0 REQUIRED)

if(ENABLE_ADVANCED_IM)
	bc_find_package(XercesC XercesC::XercesC xerces-c REQUIRED)
	set(HAVE_ADVANCED_IM 1)
	set(LIBXSD_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/libxsd")
endif()

if(ENABLE_SRTP)
	set(HAVE_SRTP 1)
endif()

if(ENABLE_ZRTP)
	set(HAVE_ZRTP 1)
	if(ENABLE_GOCLEAR)
		set(HAVE_GOCLEAR 1)
	endif()
endif()

if(ENABLE_SQLITE)
	bc_find_package(SQLite3 SQLite::SQLite3 sqlite3 REQUIRED)
	add_definitions(-DHAVE_SQLITE)
endif()

if(ENABLE_XML2)
	bc_find_package(LibXml2 LibXml2::LibXml2 xml2 REQUIRED)
	add_definitions(-DHAVE_XML2)
endif()

if(ENABLE_DB_STORAGE)
	# APPLE platform does not use dlopen for soci backend
	if(APPLE OR ANDROID)
		find_package(Soci REQUIRED COMPONENTS sqlite3)
	else()
		find_package(Soci REQUIRED)
	endif()
	set(HAVE_DB_STORAGE 1)
endif()

bc_find_package(ZLIB ZLIB::ZLIB zlib)
if(ZLIB_FOUND)
	set(HAVE_ZLIB 1)
endif()

if(ENABLE_TUNNEL)
	find_package(Tunnel 0.7.0)
	if(NOT Tunnel_FOUND)
		message(WARNING "Could not find the tunnel library!")
		set(ENABLE_TUNNEL OFF CACHE BOOL "Enable tunnel support." FORCE)
	endif()
endif()
if(ENABLE_LIME_X3DH)
	find_package(BZRTP 5.3.0 REQUIRED)
	find_package(Lime 5.3.0 REQUIRED)
	set(HAVE_LIME_X3DH 1)
endif()
if(ENABLE_CXX_WRAPPER OR ENABLE_CSHARP_WRAPPER OR ENABLE_JAVA_WRAPPER OR ENABLE_SWIFT_WRAPPER OR ENABLE_DOC)
	find_package(PythonInterp 3 REQUIRED)
	check_python_module(pystache)
	check_python_module(six)
	if(ENABLE_DOC)
		#check_python_module(swift_domain)
	endif()
endif()
if(ENABLE_LDAP)
	find_package(OpenLDAP REQUIRED)
endif()

if(ENABLE_FLEXIAPI)
	find_package(JsonCPP REQUIRED)
	set(HAVE_FLEXIAPI TRUE)
endif()

if(ENABLE_QRCODE)
	find_package(ZXing REQUIRED)
	add_definitions(-DQRCODE_ENABLED)
	if(ENABLE_JPEG) # Only needed for QRCode. Move from it for other
		add_definitions(-DJPEG_ENABLED)
		find_package(TurboJpeg REQUIRED)
	endif()
endif()



if(UNIX AND NOT APPLE)
	include(CheckIncludeFiles)
	check_include_files(libudev.h HAVE_LIBUDEV_H)
endif()

if(NOT WIN32)
	find_package(Iconv QUIET)
endif()
if(ANDROID)
	find_package(CpuFeatures REQUIRED)
	if(CMAKE_ANDROID_NDK_VERSION VERSION_LESS 19)
		find_package(Support REQUIRED)
	endif()
endif()

# include_directories must be called only UNDER THIS LINE in order to use our
# projects submodules first (we do NOT want to have system headers in first position)
include_directories(
	coreapi
	include
	src
	${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_CURRENT_BINARY_DIR}/coreapi/
)
set(LINPHONE_INCLUDE_DIRS
	${LIBXSD_INCLUDE_DIRS}
)

if(ANDROID)
	include_directories(${CMAKE_CURRENT_BINARY_DIR}/java)
endif()

if(ZXing_FOUND AND ZXing_USE_BUILD_INTERFACE)
	add_compile_definitions("ZXING_USE_BUILD_INTERFACE")
endif()

set(LINPHONE_CPPFLAGS )
if(NOT BUILD_SHARED_LIBS)
	list(APPEND LINPHONE_CPPFLAGS "-DLINPHONE_STATIC")
endif()
if(LINPHONE_CPPFLAGS)
	list(REMOVE_DUPLICATES LINPHONE_CPPFLAGS)
	add_definitions(${LINPHONE_CPPFLAGS})
endif()

if(ENABLE_DEBUG_LOGS)
	add_definitions("-DDEBUG_LOGS -DBCTBX_DEBUG_MODE")
endif()

# Enable stdint.h limit macros on C++ files. (Windows only.)
if(MSVC)
	add_definitions("-D__STDC_LIMIT_MACROS")
endif()

set(STRICT_OPTIONS_CPP )
set(STRICT_OPTIONS_C )
set(STRICT_OPTIONS_CXX )
set(STRICT_OPTIONS_OBJC )
if(MSVC)
	list(APPEND STRICT_OPTIONS_CPP "/wd4995") # Disable "name was marked as #pragma deprecated" warnings
	list(APPEND STRICT_OPTIONS_CPP "/wd4996") # Disable deprecated function warnings
	list(APPEND STRICT_OPTIONS_CPP "/wd4800") # Disable warning for cast from bool_t to bool
	list(APPEND STRICT_OPTIONS_CPP "/wd4251") # Disable warning for missing dll export
	if(ENABLE_STRICT)
		list(APPEND STRICT_OPTIONS_CPP "/WX")
	endif()
else()
	list(APPEND STRICT_OPTIONS_CPP
		"-Wall"
		"-Wconversion"
		"-Werror=return-type"
		"-Winit-self"
		"-Wno-error=deprecated-declarations"
		"-Wpointer-arith"
		"-Wuninitialized"
		"-Wunused"
	)
	list(APPEND STRICT_OPTIONS_CXX
		"-Wnon-virtual-dtor"
		"-Woverloaded-virtual"
	)
	CHECK_CXX_COMPILER_FLAG("-Wsuggest-override" SUGGEST_OVERRIDE)
	if (SUGGEST_OVERRIDE)
		list(APPEND STRICT_OPTIONS_CXX "-Wsuggest-override" "-Wno-error=suggest-override" )
	endif ()
	list(APPEND STRICT_OPTIONS_C "-Wstrict-prototypes" "-Werror=strict-prototypes")
	if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
		list(APPEND STRICT_OPTIONS_C "-fno-inline-small-functions")
	endif()
	if(CMAKE_C_COMPILER_ID MATCHES "Clang")
		list(APPEND STRICT_OPTIONS_CPP "-Qunused-arguments" "-Wno-array-bounds")
	endif()
	if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
		list(APPEND STRICT_OPTIONS_CXX "-x c++")
	endif()
	if(APPLE)
		list(APPEND STRICT_OPTIONS_CPP "-Wno-error=unknown-warning-option" "-Qunused-arguments" "-Wno-tautological-compare" "-Wno-unused-function" "-Wno-array-bounds")
	endif()
	if(ENABLE_STRICT)
		list(APPEND STRICT_OPTIONS_C "-Werror" "-Wextra" "-Wunused-parameter" "-Wno-missing-field-initializers" "-fno-strict-aliasing")
		list(APPEND STRICT_OPTIONS_CPP "-Werror" "-Wextra" "-Wunused-parameter" "-Wno-missing-field-initializers" "-fno-strict-aliasing")
	endif()
endif()
if(STRICT_OPTIONS_CPP)
	list(REMOVE_DUPLICATES STRICT_OPTIONS_CPP)
endif()
if(STRICT_OPTIONS_C)
	list(REMOVE_DUPLICATES STRICT_OPTIONS_C)
endif()

set(GETTEXT_PACKAGE "liblinphone")

if (APPLE AND NOT IOS)
	# See cmake/macos/Lipo.cmake. All data files will be moved to linphone-sdk/desktop.
	set(LINPHONE_DATA_DIR "linphone-sdk/desktop")
else()
	set(LINPHONE_DATA_DIR ".")
endif()
if(NOT ENABLE_RELATIVE_PREFIX)
	set(LINPHONE_DATA_DIR "${CMAKE_INSTALL_PREFIX}")
endif()

if(WIN32)
	set(LINPHONE_CONFIG_DIR "Linphone")
endif()

set(PACKAGE_LOCALE_DIR "${LINPHONE_DATA_DIR}/${CMAKE_INSTALL_DATADIR}/locale")
set(PACKAGE_DATA_DIR "${LINPHONE_DATA_DIR}/${CMAKE_INSTALL_DATADIR}")
set(PACKAGE_GRAMMAR_DIR "${LINPHONE_DATA_DIR}/${CMAKE_INSTALL_DATADIR}/belr/grammars")
set(PACKAGE_SOUND_DIR "${LINPHONE_DATA_DIR}/${CMAKE_INSTALL_DATADIR}/sounds/linphone")
set(PACKAGE_RING_DIR "${PACKAGE_SOUND_DIR}/rings")
set(PACKAGE_FREEDESKTOP_DIR "${PACKAGE_DATA_DIR}/applications")

#Setup framework structure and variables for liblinphone plugins
set(LINPHONE_FRAMEWORK_VERSION "A")

if(APPLE AND NOT IOS)
	set(LIBLINPHONE_PLUGINS_DIR "Frameworks/linphone.framework/Versions/${LINPHONE_FRAMEWORK_VERSION}/Libraries")

=== build/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

if(NOT CPACK_PACKAGE_NAME)
	set(CPACK_PACKAGE_NAME "liblinphone")
endif()

set(CPACK_SOURCE_IGNORE_FILES
	"${CMAKE_BINARY_DIR}"
	"^${PROJECT_SOURCE_DIR}/.git*"
)

set(BC_SPECFILE_NAME "liblinphone.spec")

bc_make_package_source_target()

=== console/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

set(LINPHONEC_SOURCE_FILES
	linphonec.c
	linphonec.h
	commands.c
)
set(LINPHONECSH_SOURCE_FILES
	shell.c
)

bc_apply_compile_flags(LINPHONEC_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
if(MSVC)
	get_source_file_property(COMMANDS_C_COMPILE_FLAGS commands.c COMPILE_FLAGS)
	set(COMMANDS_C_COMPILE_FLAGS "${COMMANDS_C_COMPILE_FLAGS} /wd4996") # Disable "was declared deprecated" warnings
	set_source_files_properties(commands.c PROPERTY COMPILE_FLAGS "${COMMANDS_C_COMPILE_FLAGS}")
endif()

add_executable(linphonec ${LINPHONEC_SOURCE_FILES})
target_link_libraries(linphonec PRIVATE ${LINPHONE_LIBS_FOR_TOOLS} ${Mediastreamer2_TARGET} ${Ortp_TARGET} ${BCToolbox_TARGET} ${XSD_LIBRARIES})
set_target_properties(linphonec PROPERTIES LINKER_LANGUAGE CXX)

if(INTL_FOUND)
	target_link_libraries(linphonec ${INTL_LIBRARIES})
endif()

if(WIN32)
	add_executable(linphoned WIN32 ${LINPHONEC_SOURCE_FILES})
	target_link_libraries(linphoned PRIVATE ${LINPHONE_LIBS_FOR_TOOLS} ${Mediastreamer2_TARGET} ${Ortp_TARGET} ${BCToolbox_TARGET} ${XSD_LIBRARIES})
	if(INTL_FOUND)
		target_link_libraries(linphoned PRIVATE ${INTL_LIBRARIES})
	endif()
endif()

add_executable(linphonecsh ${LINPHONECSH_SOURCE_FILES})
target_link_libraries(linphonecsh PRIVATE ${LINPHONE_LIBS_FOR_TOOLS} ${Ortp_TARGET} ${BCToolbox_TARGET})
set_target_properties(linphonecsh PROPERTIES LINKER_LANGUAGE CXX)

set(INSTALL_TARGETS linphonec linphonecsh)
if(WIN32)
	list(APPEND INSTALL_TARGETS linphoned)
endif()

install(TARGETS ${INSTALL_TARGETS}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== coreapi/CMakeLists.txt ===
#[[
Copyright (c) 2010-2023 Belledonne Communications SARL.

This file is part of Liblinphone 
(see https://gitlab.linphone.org/BC/public/liblinphone).

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
]]

list(APPEND LINPHONE_PRIVATE_HEADER_FILES
	bellesip_sal/sal_impl.h
	carddav.h
	conference.h
	conference-cbs.h
	local_conference.h
	remote_conference.h
	contact_providers_priv.h
	core_private.h
	enum.h
	lpc2xml.h
	private.h
	quality_reporting.h
	sqlite3_bctbx_vfs.h
	vcard_private.h
	xml2lpc.h
)

set(LINPHONE_SOURCE_FILES_C
	authentication.c
	bellesip_sal/sal_address_impl.c
	bellesip_sal/sal_impl.c
	bellesip_sal/sal_op_impl.c
	bellesip_sal/sal_sdp.c
	buffer.c
	callbacks.c
	chat.c
	contactprovider.c
	ec-calibrator.c
	echo-tester.c
	enum.c
	error_info.c
	friend.c
	friendlist.c
	im_notif_policy.c
	info.c
	im_encryption_engine.c
	linphonecall.c
	linphonecore.c
	linphoneconference.c
	linphone_tunnel_config.c
	localplayer.c
	logging.c
	lpconfig.c
	lsd.c
	misc.c
	player.c
	presence.c
	proxy.c
	quality_reporting.c
	remote_provisioning.c
	ringtoneplayer.c
	siplogin.c
	sipsetup.c
	update_check.c
	video_definition.c
	vtables.c
	xmlrpc.c
)
set(LINPHONE_SOURCE_FILES_CXX
	conference.cpp
	local_conference.cpp
	remote_conference.cpp
	tester_utils.cpp
)

if(ENABLE_JAVA_WRAPPER)
	list(APPEND LINPHONE_SOURCE_FILES_CXX ${LINPHONE_JNI_SOURCES})
	set_source_files_properties(${LINPHONE_JNI_SOURCES} PROPERTIES GENERATED TRUE)
endif()

set(LINPHONE_SOURCE_FILES_OBJC)
if (IOS)
	list(APPEND LINPHONE_SOURCE_FILES_OBJC ringtoneplayer_ios.m ringtoneplayer_ios.h)
	list(APPEND LINPHONE_SOURCE_FILES_CXX linphonecore_ios.cc)
endif()

if(ENABLE_XML2)
	list(APPEND LINPHONE_SOURCE_FILES_C lpc2xml.c xml2lpc.c xml.c)
endif()

if(ENABLE_SQLITE)
	list(APPEND LINPHONE_SOURCE_FILES_C sqlite3_bctbx_vfs.c)
endif()

if(ENABLE_TUNNEL)
	list(APPEND LINPHONE_SOURCE_FILES_CXX
		linphone_tunnel.cc
		TunnelManager.cc
	)
	add_definitions(-DTUNNEL_ENABLED)
else()
	list(APPEND LINPHONE_SOURCE_FILES_C linphone_tunnel_stubs.c)
endif()

if(BelCard_FOUND)
	list(APPEND LINPHONE_SOURCE_FILES_CXX vcard.cc)
	list(APPEND LINPHONE_SOURCE_FILES_C carddav.c)
else()
	list(APPEND LINPHONE_SOURCE_FILES_C vcard_stubs.c)
endif()


bc_git_version(liblinphone ${PROJECT_VERSION})

add_definitions(
	-DUSE_BELLESIP
	-DBCTBX_LOG_DOMAIN="liblinphone"
	-DLINPHONE_EXPORTS
)

set_source_files_properties(${LINPHONE_SOURCE_FILES_C} PROPERTIES LANGUAGE CXX)
bc_apply_compile_flags(LINPHONE_SOURCE_FILES_C STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)
bc_apply_compile_flags(LINPHONE_SOURCE_FILES_CXX STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)
bc_apply_compile_flags(LINPHONE_SOURCE_FILES_OBJC STRICT_OPTIONS_CPP STRICT_OPTIONS_OBJC)


add_library(liblinphone-coreapi OBJECT
	${LINPHONE_PRIVATE_HEADER_FILES} ${LINPHONE_SOURCE_FILES_C} ${LINPHONE_SOURCE_FILES_CXX} ${LINPHONE_SOURCE_FILES_OBJC}
)
target_include_directories(liblinphone-coreapi PRIVATE ${LINPHONE_INCLUDE_DIRS})
target_link_libraries(liblinphone-coreapi PRIVATE ${BelleSIP_TARGET} ${Belr_TARGET} ${Mediastreamer2_TARGET} ${Ortp_TARGET})
if(LibXml2_FOUND)
	target_link_libraries(liblinphone-coreapi PRIVATE ${LibXml2_TARGET})
endif()
if(XercesC_FOUND)
	target_link_libraries(liblinphone-coreapi PRIVATE ${XercesC_TARGET})
endif()
if(SQLite3_FOUND)
	target_link_libraries(liblinphone-coreapi PRIVATE ${SQLite3_TARGET})
endif()
if(Tunnel_FOUND)
	target_link_libraries(liblinphone-coreapi PRIVATE ${Tunnel_TARGET})
endif()
if(BelCard_FOUND)
	target_link_libraries(liblinphone-coreapi PRIVATE ${BelCard_TARGET})
endif()
if(ZLIB_FOUND)
	target_link_libraries(liblinphone-coreapi PRIVATE ${ZLIB_TARGET})
endif()
if(CpuFeatures_FOUND)
	target_link_libraries(liblinphone-coreapi PRIVATE ${CpuFeatures_TARGET})
endif()
add_dependencies(liblinphone-coreapi liblinphone-git-version)
if(ENABLE_JAVA_WRAPPER)
	add_dependencies(liblinphone-coreapi linphonej)
endif()

if(BUILD_SHARED_LIBS)
	set_target_properties(liblinphone-coreapi PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
endif()


add_subdirectory(help)

=== daemon/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

set(DAEMON_SOURCE_FILES
	commands/adaptive-jitter-compensation.cc
	commands/adaptive-jitter-compensation.h
	commands/answer.cc
	commands/answer.h
	commands/audio-codec-get.cc
	commands/audio-codec-get.h
	commands/audio-codec-move.cc
	commands/audio-codec-move.h
	commands/audio-codec-set.cc
	commands/audio-codec-set.h
	commands/audio-codec-toggle.cc
	commands/audio-codec-toggle.h
	commands/audio-stream-start.cc
	commands/audio-stream-start.h
	commands/audio-stream-stats.cc
	commands/audio-stream-stats.h
	commands/audio-stream-stop.cc
	commands/audio-stream-stop.h
	commands/auth-infos-clear.cc
	commands/auth-infos-clear.h
	commands/call.cc
	commands/call.h
	commands/call-mute.cc
	commands/call-mute.h
	commands/call-pause.cc
	commands/call-pause.h
	commands/call-resume.cc
	commands/call-resume.h
	commands/call-stats.cc
	commands/call-stats.h
	commands/call-status.cc
	commands/call-status.h
	commands/call-transfer.cc
	commands/call-transfer.h
	commands/cn.cc
	commands/cn.h
	commands/conference.cc
	commands/conference.h
	commands/config.cc
	commands/configcommand.h
	commands/contact.cc
	commands/contact.h
	commands/dtmf.cc
	commands/dtmf.h
	commands/echo.cc
	commands/echo.h
	commands/firewall-policy.cc
	commands/firewall-policy.h
	commands/help.cc
	commands/help.h
	commands/ipv6.cc
	commands/ipv6.h
	commands/jitterbuffer.cc
	commands/jitterbuffer.h
	commands/media-encryption.cc
	commands/media-encryption.h
	commands/msfilter-add-fmtp.cc
	commands/msfilter-add-fmtp.h
	commands/netsim.cc
	commands/netsim.h
	commands/play.cc
	commands/play.h
	commands/play-wav.cc
	commands/play-wav.h
	commands/pop-event.cc
	commands/pop-event.h
	commands/port.cc
	commands/port.h
	commands/ptime.cc
	commands/ptime.h
	commands/quit.cc
	commands/quit.h
	commands/register.cc
	commands/register.h
	commands/register-info.cc
	commands/register-status.cc
	commands/register-status.h
	commands/terminate.cc
	commands/terminate.h
	commands/unregister.cc
	commands/unregister.h
	commands/version.cc
	commands/version.h
	commands/video.cc
	commands/video.h
	commands/message.cc
	commands/message.h
	daemon.cc
	daemon.h
)

set(DAEMON_PIPETEST_SOURCE_FILES
	daemon-pipetest.c
)
set(DAEMON_SOURCE_FILES_OBJC )
if(APPLE)
	list(APPEND DAEMON_SOURCE_FILES_OBJC ../src/utils/main-loop-integration-macos.m)
endif()

bc_apply_compile_flags(DAEMON_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)
bc_apply_compile_flags(DAEMON_PIPETEST_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
bc_apply_compile_flags(DAEMON_SOURCE_FILES_OBJC STRICT_OPTIONS_CPP STRICT_OPTIONS_OBJC)
add_executable(linphone-daemon ${DAEMON_SOURCE_FILES} ${DAEMON_SOURCE_FILES_OBJC})
target_include_directories(linphone-daemon PRIVATE ${CMAKE_CURRENT_LIST_DIR} ${LINPHONE_INCLUDE_DIRS})
target_link_libraries(linphone-daemon PRIVATE ${LINPHONE_LIBS_FOR_TOOLS} ${BelleSIP_TARGET} ${Mediastreamer2_TARGET} ${Ortp_TARGET} ${BCToolbox_TARGET} ${XSD_LIBRARIES})
set_target_properties(linphone-daemon PROPERTIES LINKER_LANGUAGE CXX)
if(APPLE)
	target_link_libraries(linphone-daemon PRIVATE "-framework AppKit")
endif()

add_executable(linphone-daemon-pipetest ${DAEMON_PIPETEST_SOURCE_FILES})
target_link_libraries(linphone-daemon-pipetest PRIVATE ${LINPHONE_LIBS_FOR_TOOLS} ${Mediastreamer2_TARGET} ${Ortp_TARGET})
set_target_properties(linphone-daemon-pipetest PROPERTIES LINKER_LANGUAGE CXX)

set(INSTALL_TARGETS linphone-daemon linphone-daemon-pipetest)

install(TARGETS ${INSTALL_TARGETS}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== src/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

set(LINK_LIBS
	${BCToolbox_TARGET}
	${Belr_TARGET}
)
set(PUBLIC_LINK_LIBS
	${Ortp_TARGET}
	${Mediastreamer2_TARGET}
	${BelleSIP_TARGET}
)

#APPLE_LIBS is mandatory for apple compilation
if(APPLE)
	list(APPEND APPLE_LIBS "-framework CFNetwork -framework Foundation -framework AVFoundation -framework SystemConfiguration -framework CoreLocation")
	if(IOS)
		list(APPEND APPLE_LIBS "-framework UIKit -framework PushKit -framework CallKit")
	endif()
endif()

if(LibXml2_FOUND)
	list(APPEND PUBLIC_LINK_LIBS ${LibXml2_TARGET})
endif()

if(HAVE_DLOPEN)
	list(APPEND LINK_LIBS dl)
endif()

if(ENABLE_ADVANCED_IM)
	list(APPEND LINK_LIBS ${XercesC_TARGET})
	if (APPLE AND NOT IOS)
		list(APPEND APPLE_LIBS "-framework CoreServices")
	endif()
endif()

if(Lime_FOUND)
	list(APPEND PUBLIC_LINK_LIBS ${Lime_TARGET})
endif ()
if(ENABLE_LIME_X3DH)
	list(APPEND LINK_LIBS ${BZRTP_TARGET})
endif()
if(ZLIB_FOUND)
	list(APPEND LINK_LIBS ${ZLIB_TARGET})
endif()
if(ENABLE_DB_STORAGE)
	if(Soci_FOUND)
		list(APPEND LINK_LIBS ${Soci_sqlite3_TARGET} ${Soci_TARGET})
	endif()
endif()
if(SQLite3_FOUND)
	list(APPEND PUBLIC_LINK_LIBS ${SQLite3_TARGET})
endif()
if(Iconv_FOUND)
	list(APPEND LINK_LIBS Iconv::Iconv)
endif()
if(Tunnel_FOUND)
	list(APPEND LINK_LIBS ${Tunnel_TARGET})
	add_definitions(-DTUNNEL_ENABLED)
endif()

if(WIN32 AND NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsPhone" AND NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
	list(APPEND LINK_LIBS shlwapi)
endif()
if(INTL_FOUND)
	list(APPEND LINK_LIBS ${INTL_LIBRARIES})
endif()
if(BelCard_FOUND)
	list(APPEND LINK_LIBS ${BelCard_TARGET})
endif()
if(OpenLDAP_FOUND)
	list(APPEND LINK_LIBS ${OpenLDAP_TARGETS})
	add_definitions(-DBUILD_LDAP)
endif()
if(ZXing_FOUND)
	list(APPEND LINK_LIBS ${ZXing_TARGET})
endif()
if(TurboJpeg_FOUND)
	list(APPEND LINK_LIBS ${TurboJpeg_TARGET})
endif()

#define log domain for this part of code
add_definitions(-DBCTBX_LOG_DOMAIN="liblinphone")

set(LINPHONE_CXX_OBJECTS_PRIVATE_HEADER_FILES
	account/account.h
	account/account-params.h
	address/address.h
	address/address-parser.cpp
	alert/alert.h
	auth-info/auth-info.h
	auth-info/auth-stack.h
	c-wrapper/c-wrapper.h
	c-wrapper/list-holder.h
	c-wrapper/internal/c-sal.h
	c-wrapper/internal/c-tools.h
	call/call-log.h
	call/call.h
	call/video-source/video-source-descriptor.h
	call/audio-device/audio-device.h
	call/audio-device/audio-device.cpp
	chat/chat-message/chat-message-p.h
	chat/chat-message/chat-message-reaction.h
	chat/chat-message/chat-message.h
	chat/chat-message/chat-message-listener.h
	chat/chat-message/imdn-message-p.h
	chat/chat-message/imdn-message.h
	chat/chat-message/is-composing-message.h
	chat/chat-message/notification-message-p.h
	chat/chat-message/notification-message.h
	chat/chat-room/chat-room-params.h
	chat/chat-room/abstract-chat-room-p.h
	chat/chat-room/abstract-chat-room.h
	chat/chat-room/basic-chat-room-p.h
	chat/chat-room/basic-chat-room.h
	chat/chat-room/chat-room-listener.h
	chat/chat-room/chat-room-p.h
	chat/chat-room/chat-room.h
	chat/cpim/cpim.h
	chat/cpim/header/cpim-core-headers.h
	chat/cpim/header/cpim-generic-header.h
	chat/cpim/header/cpim-header-p.h
	chat/cpim/header/cpim-header.h
	chat/cpim/message/cpim-message.h
	chat/cpim/parser/cpim-parser.h
	chat/encryption/encryption-engine.h
	chat/encryption/legacy-encryption-engine.h
	chat/ics/ics.h
	chat/ics/parser/ics-parser.h
	chat/modifier/chat-message-modifier.h
	chat/modifier/cpim-chat-message-modifier.h
	chat/modifier/encryption-chat-message-modifier.h
	chat/modifier/file-transfer-chat-message-modifier.h
	chat/modifier/multipart-chat-message-modifier.h
	chat/notification/imdn.h
	chat/notification/is-composing-listener.h
	chat/notification/is-composing.h
	conference/conference-params.h
	conference/conference-params-interface.h
	conference/conference-enums.h
	conference/conference-id.h
	conference/conference-info.h
	conference/conference-scheduler.h
	conference/conference-listener.h
	conference/notify-conference-listener.h
	conference/conference.h
	conference/local-conference.h
	conference/params/call-session-params-p.h
	conference/params/call-session-params.h
	conference/params/media-session-params-p.h
	conference/params/media-session-params.h
	conference/participant-info.h
	conference/participant-device.h
	conference/participant-imdn-state-p.h
	conference/participant-imdn-state.h
	conference/participant.h
	conference/remote-conference.h
	conference/session/call-session-listener.h
	conference/session/call-session-p.h
	conference/session/call-session.h
	conference/session/media-session.h
	conference/session/streams.h
	conference/session/port-config.h
	conference/session/tone-manager.h
	conference/session/ms2-streams.h
	conference/session/media-description-renderer.h
	conference/session/mixers.h
	containers/lru-cache.h
	content/content-disposition.h
	content/content-manager.h
	content/content-type.h
	content/content.h
	content/file-content.h
	content/file-transfer-content.h
	content/header/header-p.h
	content/header/header-param.h
	content/header/header.h
	core/core-accessor.h
	core/core-listener.h
	core/core-p.h
	core/core.h
	core/paths/paths.h
	core/platform-helpers/platform-helpers.h
	core/shared-core-helpers/shared-core-helpers.h
	db/abstract/abstract-db-p.h
	db/abstract/abstract-db.h
	db/internal/statements.h
	db/main-db-event-key.h
	db/main-db-key-p.h
	db/main-db-key.h
	db/main-db-p.h
	db/main-db.h
	dial-plan/dial-plan.h
	dictionary/dictionary.h
	enums.h
	event/event.h
	event/event-publish.h
	event/event-subscribe.h
	event-log/conference/conference-call-event.h
	event-log/conference/conference-event-p.h
	event-log/conference/conference-event.h
	event-log/conference/conference-notified-event-p.h
	event-log/conference/conference-notified-event.h
	event-log/conference/conference-ephemeral-message-event.h
	event-log/conference/conference-participant-device-event.h
	event-log/conference/conference-participant-event-p.h
	event-log/conference/conference-participant-event.h
	event-log/conference/conference-security-event.h
	event-log/conference/conference-subject-event.h
	event-log/conference/conference-available-media-event.h
	event-log/event-log-p.h
	event-log/event-log.h
	event-log/events.h
	factory/factory.h
	friend/friend_phone_number.h
	hacks/hacks.h
	ldap/ldap.h
	ldap/ldap-config-keys.h
	ldap/ldap-params.h
	logger/logger.h
	nat/ice-service.h
	nat/stun-client.h
	nat/nat-policy.h
	object/base-object-p.h
	object/base-object.h
	object/clonable-object-p.h
	object/clonable-object.h
	object/clonable-shared-pointer.h
	object/object-head-p.h
	object/object-head.h
	object/object-p.h
	object/object.h
	object/property-container.h
	object/singleton.h
	payload-type/payload-type.h
	push-notification-message/push-notification-message.h
	push-notification/push-notification-config.h
	recorder/recorder.h
	recorder/recorder-params.h
	sal/sal.h
	sal/sal_stream_bundle.h
	sal/sal_stream_description.h
	sal/sal_stream_configuration.h
	sal/sal_media_description.h
	sal/params/sal_media_description_params.h
	sal/offeranswer.h
	sal/potential_config_graph.h
	search/search-async-data.h
	search/magic-search-p.h
	search/magic-search.h
	search/search-request.h
	search/search-result.h
	signal-information/signal-information.h
	utils/background-task.h
	utils/custom-params.h
	utils/general-internal.h
	utils/payload-type-handler.h
	utils/if-addrs.h
	variant/variant.h
	variant/variant-impl.h
)

if(ENABLE_ADVANCED_IM)
	list(APPEND LINPHONE_CXX_OBJECTS_PRIVATE_HEADER_FILES
		chat/chat-room/basic-to-client-group-chat-room.h
		chat/chat-room/client-group-chat-room-p.h
		chat/chat-room/client-group-chat-room.h
		chat/chat-room/client-group-to-basic-chat-room.h
		chat/chat-room/proxy-chat-room-p.h
		chat/chat-room/proxy-chat-room.h
		chat/chat-room/server-group-chat-room-p.h
		chat/chat-room/server-group-chat-room.h
		conference/handlers/local-audio-video-conference-event-handler.h
		conference/handlers/local-conference-event-handler.h
		conference/handlers/local-conference-list-event-handler.h
		conference/handlers/remote-conference-event-handler-base.h
		conference/handlers/remote-conference-event-handler.h
		conference/handlers/remote-conference-list-event-handler.h
		xml/conference-info.h
		xml/conference-info-linphone-extension.h
		xml/imdn.h
		xml/is-composing.h
		xml/linphone-imdn.h
		xml/publish-linphone-extension.h
		xml/resource-lists.h
		xml/rlmi.h
		xml/xml.h
	)
endif()

if(ENABLE_LDAP)
	list(APPEND LINPHONE_CXX_OBJECTS_PRIVATE_HEADER_FILES
		ldap/ldap-contact-fields.h
		ldap/ldap-contact-provider.h
		ldap/ldap-contact-search.h
		)
endif()

if(ENABLE_DB_STORAGE)
	list(APPEND LINPHONE_CXX_OBJECTS_PRIVATE_HEADER_FILES
		db/internal/db-transaction.h
		db/session/db-session.h
	)
endif()

set(LINPHONE_CXX_OBJECTS_SOURCE_FILES
	account/account.cpp
	account/account-params.cpp
	account_creator/utils.cpp
	account_creator/service.cpp
	account_creator/main.cpp
	account_creator/connector_xmlrpc.cpp
	address/address.cpp
	address/address-parser.cpp
	alert/alert.cpp
	auth-info/auth-info.cpp
	auth-info/auth-stack.cpp
	c-wrapper/c-wrapper.cpp
	c-wrapper/api/c-digest-authentication-policy.cpp
	c-wrapper/api/c-account.cpp
	c-wrapper/api/c-account-cbs.cpp
	c-wrapper/api/c-account-params.cpp
	c-wrapper/api/c-address.cpp
	c-wrapper/api/c-alert-cbs.cpp
	c-wrapper/api/c-alert.cpp
	c-wrapper/api/c-audio-device.cpp
	c-wrapper/api/c-auth-info.cpp
	c-wrapper/api/c-call-cbs.cpp
	c-wrapper/api/c-call-log.cpp
	c-wrapper/api/c-call-params.cpp
	c-wrapper/api/c-call-stats.cpp
	c-wrapper/api/c-call.cpp
	c-wrapper/api/c-chat-message-cbs.cpp
	c-wrapper/api/c-chat-message-reaction.cpp
	c-wrapper/api/c-chat-message.cpp
	c-wrapper/api/c-chat-room-params.cpp
	c-wrapper/api/c-chat-room-cbs.cpp
	c-wrapper/api/c-chat-room.cpp
	c-wrapper/api/c-content.cpp
	c-wrapper/api/c-conference-cbs.cpp
	c-wrapper/api/c-conference-info.cpp
	c-wrapper/api/c-conference-scheduler.cpp
	c-wrapper/api/c-conference.cpp
	c-wrapper/api/c-core.cpp
	c-wrapper/api/c-dial-plan.cpp
	c-wrapper/api/c-dictionary.cpp
	c-wrapper/api/c-event-cbs.cpp
	c-wrapper/api/c-event-log.cpp
	c-wrapper/api/c-event.cpp
	c-wrapper/api/c-factory.cpp
	c-wrapper/api/c-friend-phone-number.cpp
	c-wrapper/api/c-ldap.cpp
	c-wrapper/api/c-ldap-params.cpp
	c-wrapper/api/c-magic-search.cpp
	c-wrapper/api/c-magic-search-cbs.cpp
	c-wrapper/api/c-participant.cpp
	c-wrapper/api/c-participant-info.cpp
	c-wrapper/api/c-participant-device.cpp
	c-wrapper/api/c-participant-device-cbs.cpp
	c-wrapper/api/c-participant-device-identity.cpp
	c-wrapper/api/c-participant-imdn-state.cpp
	c-wrapper/api/c-participant.cpp
	c-wrapper/api/c-payload-type.cpp
	c-wrapper/api/c-push-notification-message.cpp
	c-wrapper/api/c-push-notification-config.cpp
	c-wrapper/api/c-recorder.cpp
	c-wrapper/api/c-recorder-params.cpp
	c-wrapper/api/c-search-result.cpp
	c-wrapper/api/c-signal-information.cpp
	c-wrapper/api/c-video-source-descriptor.cpp
	c-wrapper/api/c-nat-policy.cpp
	c-wrapper/internal/c-sal.cpp

=== tester/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

set(OTHER_LIBS_FOR_TESTER
	${BCToolbox_tester_TARGET}
	${Ortp_TARGET}
	${Mediastreamer2_TARGET}
	${BelleSIP_TARGET}
	${Belr_TARGET}
	${LibXml2_TARGET}
	${XSD_LIBRARIES}
)

if(INTL_FOUND)
	list(APPEND OTHER_LIBS_FOR_TESTER ${INTL_LIBRARIES})
endif()
if(SQLITE3_FOUND)
	list(APPEND OTHER_LIBS_FOR_TESTER ${SQLITE3_LIBRARIES})
endif()
if(Soci_FOUND)
	list(APPEND OTHER_LIBS_FOR_TESTER ${Soci_TARGET} ${Soci_sqlite3_TARGET})
	add_definitions(-DHAVE_SOCI=1)
endif()
if(ZLIB_FOUND)
	list(APPEND OTHER_LIBS_FOR_TESTER ${ZLIB_TARGET})
endif()
if(OpenLDAP_FOUND)
	list(APPEND OTHER_LIBS_FOR_TESTER ${OpenLDAP_TARGETS})
endif()
if(ZXing_FOUND)
	list(APPEND OTHER_LIBS_FOR_TESTER ${ZXing_TARGET})
endif()
if(TurboJpeg_FOUND)
	list(APPEND OTHER_LIBS_FOR_TESTER ${TurboJpeg_TARGET})
endif()
if(XercesC_FOUND)
	list(APPEND OTHER_LIBS_FOR_TESTER ${XercesC_TARGET})
endif()

if(ENABLE_CXX_WRAPPER)
	list(APPEND OTHER_LIBS_FOR_TESTER liblinphone++)
endif()

set(SOUND_FILES
	sounds/ahbahouaismaisbon.wav
	sounds/special-&_characters.wav
	sounds/continuous_48000_stereo.wav
	sounds/hello44100.wav
	sounds/hello8000.mkv
	sounds/hello8000_mkv_ref.wav
	sounds/hello8000.wav
	sounds/oldphone.wav
	sounds/ringback.wav
	sounds/sintel_trailer_opus_h264.mkv
	sounds/sintel_trailer_opus_vp8.mkv
	sounds/sintel_trailer_pcmu_h264.mkv
	sounds/recording.mkv
	sounds/vrroom.wav
)

set(SIPP_FILES
	sipp/call_invite_200ok_without_contact_header.xml
	sipp/call_with_audio_mline_before_video_in_sdp.xml
	sipp/call_with_multiple_audio_mline_in_sdp.xml
	sipp/call_with_multiple_video_mline_in_sdp.xml
	sipp/call_with_video_mline_before_audio_in_sdp.xml
	sipp/sip_update_within_icoming_reinvite_with_no_sdp.xml
	sipp/call_with_transfer_incoming_ringing_call.xml
)

set(CERTIFICATE_ALT_FILES
	certificates/altname/agent.pem
	certificates/altname/cafile.pem
	certificates/altname/openssl-altname.cnf
)

set(CERTIFICATE_CN_FILES
	certificates/cn/agent.pem
	certificates/cn/cafile.pem
	certificates/cn/openssl-cn.cnf
)

set(CERTIFICATE_CLIENT_FILES
	certificates/client/cert.pem
	certificates/client/key.pem
	certificates/client/cert2.pem
	certificates/client/key2.pem
	certificates/client/cert3.pem
	certificates/client/key3.pem
	certificates/client/cert2-signed-by-other-ca.pem
	certificates/client/key2-signed-by-other-ca.pem
	certificates/client/user1_cert.pem
	certificates/client/user1_key.pem
	certificates/client/user1_multiple_aliases_cert.pem
	certificates/client/user1_multiple_aliases_key.pem
	certificates/client/user2_cert.pem
	certificates/client/user2_key.pem
	certificates/client/user2_CN_cert.pem
	certificates/client/user2_CN_key.pem
	certificates/client/user2_revoked_cert.pem
	certificates/client/user2_revoked_key.pem
)

set(CERTIFICATE_FILES ${CERTIFICATE_ALT_FILES} ${CERTIFICATE_CN_FILES} ${CERTIFICATE_CLIENT_FILES})

set(DB_FILES
	db/call-history.db
	db/friends.db
	db/linphone.db
	db/messages.db
	db/chatrooms.db
	db/chatroom_conference.db
)

set(RC_FILES
	rcfiles/account_creator_rc
	rcfiles/account_creator_flexiapi_rc
	rcfiles/assistant_create.rc
	rcfiles/berthe_rc
	rcfiles/carddav_rc
	rcfiles/claire_rc
	rcfiles/claire_sips_rc
	rcfiles/chloe_rc
	rcfiles/conference_focus_rc
	rcfiles/empty_rc
	rcfiles/friends_rc
	rcfiles/groupchat_rc
	rcfiles/invalid_friends_rc
	rcfiles/invalid_friends_xml
	rcfiles/laure_call_logs_rc
	rcfiles/laure_rc_udp
	rcfiles/laure_tcp_rc
	rcfiles/lise_rc
	rcfiles/marie2_rc
	rcfiles/marie_bodyless_rc
	rcfiles/marie_dependent_proxy_rc
	rcfiles/marie_dtls_srtp_immediate_rc
	rcfiles/marie_dual_proxy_2_rc
	rcfiles/marie_dual_proxy_rc
	rcfiles/marie_dual_proxy_udp_rc
	rcfiles/marie_early_rc
	rcfiles/marie_h264_rc
	rcfiles/marie_nat64_rc
	rcfiles/marie_quality_reporting_rc
	rcfiles/marie_rc
	rcfiles/marie_rc_call_logs_migration
	rcfiles/marie_rtp_port_range_rc
	rcfiles/marie_os_defined_rtp_ports_rc
	rcfiles/marie_rc_rtcp_xr
	rcfiles/marie_remote_404_rc
	rcfiles/marie_remote_default_values_rc
	rcfiles/marie_remote_https_rc
	rcfiles/marie_remote_invalid_rc
	rcfiles/marie_remote_invalid_uri_rc
	rcfiles/marie_remote_localfile2_rc
	rcfiles/marie_remote_localfile_android_rc
	rcfiles/marie_remote_localfile_rc
	rcfiles/marie_remote_localfile_win10_rc
	rcfiles/marie_remote_rc
	rcfiles/marie_session_timers_rc
	rcfiles/marie_sips_rc
	rcfiles/marie_transient_remote_rc
	rcfiles/marie_v4proxy_rc
	rcfiles/marie_well_known_port_rc
	rcfiles/michelle_rc
	rcfiles/michelle_rc_udp
	rcfiles/multi_account_rc
	rcfiles/multi_account2_rc
	rcfiles/pauline_alt_rc
	rcfiles/pauline_as_friend_rc
	rcfiles/pauline_dtls_srtp_immediate_rc
	rcfiles/pauline_external_rc
	rcfiles/pauline_h264_rc
	rcfiles/pauline_nat64_rc
	rcfiles/pauline_rc
	rcfiles/pauline_rtp_port_range_rc
	rcfiles/pauline_os_defined_rtp_ports_rc
	rcfiles/pauline_rc_rtcp_xr
	rcfiles/pauline_sips_rc
	rcfiles/pauline_tcp_rc
	rcfiles/pauline_tls_client_rc
	rcfiles/pauline_tunnel_verify_server_certificate_rc
	rcfiles/pauline_v4proxy_rc
	rcfiles/pauline_well_known_port_rc
	rcfiles/pauline_wild_rc
	rcfiles/remote_zero_length_params_rc
	rcfiles/stun_rc
	rcfiles/zero_length_params_rc
	rcfiles/marie_bodyless_rc
	rcfiles/groupchat_rc
	rcfiles/arthur_rc
)

set(IMAGE_FILES
	images/linphone.svg
	images/linphonesiteqr.jpg
	images/linphonesiteqr_captured.jpg
	images/nowebcamCIF.jpg
	images/nowebcamVGA.jpg
)

set(VCARD_FILES
	vcards/thousand_vcards.vcf
	vcards/vcards.vcf
)

set(OTHER_FILES
	tester_hosts
	local_tester_hosts
)

set(IOS_RESOURCES_FILES
	${OTHER_FILES}
	${DB_FILES}
	certificates
	images
	rcfiles
	sipp
	sounds
	vcards
)

set(SOURCE_FILES_C
	account_tester.c
	account_creator_local_tester.c
	account_creator_xmlrpc_tester.c
	accountmanager.c
	audio_bypass_tester.c
	audio_routes_tester.c
	audio_video_conference_tester.c
	call_multicast_tester.c
	call_multi_tester.c
	call_race_conditions.c
	call_push_incoming_tester.c
	call_recovery_tester.c
	call_single_tester.c
	call_with_rtp_bundle_tester.c
	complex_sip_case_tester.c
	dtmf_tester.c
	eventapi_tester.c
	external_domain_tester.c
	flexisip_tester.c
	group_chat_tester.c
	group_chat_ephemeral_tester.c
	group_chat_secure_tester.c
	liblinphone_tester.c
	log_collection_tester.c
	log_file_tester.c
	message_tester.c
	player_tester.c
	presence_server_tester.c
	presence_tester.c
	proxy_config_tester.c
	quality_reporting_tester.c
	recorder_tester.c
	register_tester.c
	session_timers_tester.c
	setup_tester.c
	shared_core_tester.c
	stun_tester.c
	tunnel_tester.c
	vcard_tester.c
	video_quality_tester.c
	local_chat_tester_functions.cpp
	local_conference_tester_functions.cpp
	local_scheduled_conference_tester.cpp
	local_ice_conference_tester.cpp
	local_inpromptu_conference_tester.cpp
	local_conference_edition_tester.cpp
	local_chat_tester.cpp
	local_chat_imdn_tester.cpp
	local_secure_chat_tester.cpp
	local_ephemeral_chat_tester.cpp
	video_tester.c
)

if(ENABLE_LIME_X3DH)
	list(APPEND SOURCE_FILES_C group_chat_secure_tester.c)
endif()

if(NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
	list(APPEND SOURCE_FILES_C tester.c)# it will be added on RUNTIME_COMPONENT_SOURCES
endif()

set(SOURCE_FILES_CXX
	tester.cpp
	audio-quality-tester.cpp
	clonable-object-tester.cpp
	call_video_tester.cpp
	call_flexfec_tester.cpp
	call_ice_tester.cpp
	call_secure_tester.cpp
	capability_negotiation_tester.cpp
	dtmf_tester.cpp
	ice_capability_negotiation_tester.cpp
	srtp_capability_negotiation_tester.cpp
	zrtp_capability_negotiation_tester.cpp
	dtls_srtp_capability_negotiation_tester.cpp
	remote-provisioning-tester.cpp
	contents-tester.cpp
	multipart-tester.cpp
	offeranswer_tester.cpp
	shared_tester_functions.cpp
	property-container-tester.cpp
	utils-tester.cpp
	lime-user-authentication-tester.cpp
	vfs-encryption-tester.cpp
	potential_configuration_tester.cpp
	conference-info-tester.cpp
	alerts_tester.cpp
)

if(ENABLE_FLEXIAPI)
	list(APPEND SOURCE_FILES_CXX account_creator_flexiapi_tester.cpp)
	list(APPEND SOURCE_FILES_CXX flexiapiclient-tester.cpp)
endif()

if(ENABLE_ADVANCED_IM)
	list(APPEND SOURCE_FILES_CXX 	conference-event-tester.cpp
									cpim-tester.cpp
									ics-tester.cpp)
endif()

if(ENABLE_DB_STORAGE)
	list(APPEND SOURCE_FILES_CXX main-db-tester.cpp)
endif()

if(ENABLE_CXX_WRAPPER)
	list(APPEND SOURCE_FILES_CXX wrapper_cpp_tester.cpp)
endif()

set(HEADER_FILES
	audio_quality_tester.h
	shared_tester_functions.h
	local_conference_tester_functions.h
	capability_negotiation_tester.h
	liblinphone_tester.h
	tools/private-access.h
	tools/tester.h
)

set(SOURCE_FILES_OBJC )
if(APPLE)
	if (IOS)
		list(APPEND SOURCE_FILES_OBJC liblinphone_tester_ios.m)
	else()
		list(APPEND SOURCE_FILES_OBJC ../src/utils/main-loop-integration-macos.m)#Override main(), instantiate Main Loop and call apple_main()
	endif()
endif()

set(GROUP_CHAT_BENCHMARK_SOURCE_C
	accountmanager.c
	tester.c
	group_chat_tester.c
	group_chat_benchmark.c
)

set(GROUP_CHAT_BENCHMARK_SOURCE_CXX
	shared_tester_functions.cpp
	tester.cpp
)

set(GROUP_CHAT_BENCHMARK_HEADERS
	shared_tester_functions.h
	liblinphone_tester.h
	tools/tester.h
)

set(LINPHONETESTER_RESOURCES
	"${CMAKE_CURRENT_SOURCE_DIR}/certificates"
	"${CMAKE_CURRENT_SOURCE_DIR}/db"
	"${CMAKE_CURRENT_SOURCE_DIR}/images"
	"${CMAKE_CURRENT_SOURCE_DIR}/rcfiles"
	"${CMAKE_CURRENT_SOURCE_DIR}/sipp"
	"${CMAKE_CURRENT_SOURCE_DIR}/sounds"
	"${CMAKE_CURRENT_SOURCE_DIR}/vcards"
	"${CMAKE_CURRENT_SOURCE_DIR}/tester_hosts"
	"${CMAKE_CURRENT_SOURCE_DIR}/local_tester_hosts"
)

# TODO: Remove me later!
list(REMOVE_ITEM STRICT_OPTIONS_CPP "-Wconversion" "-Werror=conversion" "-Wcast-align" "-Werror=cast-align")
if (ANDROID AND CMAKE_C_COMPILER_ID STREQUAL "GNU") #restrict to Android as it seems to break regular linux
	list (APPEND STRICT_OPTIONS_C "-std=c99")
endif()

bc_apply_compile_flags(SOURCE_FILES_C STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
bc_apply_compile_flags(SOURCE_FILES_CXX STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)
bc_apply_compile_flags(SOURCE_FILES_OBJC STRICT_OPTIONS_CPP STRICT_OPTIONS_OBJC)

bc_apply_compile_flags(GROUP_CHAT_BENCHMARK_SOURCE_C STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
bc_apply_compile_flags(GROUP_CHAT_BENCHMARK_SOURCE_CXX STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)

add_definitions("-DLINPHONE_TESTER")

if(MSVC)
	get_source_file_property(MESSAGE_TESTER_C_COMPILE_FLAGS message_tester.c COMPILE_FLAGS)
	set(MESSAGE_TESTER_C_COMPILE_FLAGS "${MESSAGE_TESTER_C_COMPILE_FLAGS} /wd4996") # Disable "was declared deprecated" warnings
	set_source_files_properties(message_tester.c PROPERTY COMPILE_FLAGS "${MESSAGE_TESTER_C_COMPILE_FLAGS}")
	get_source_file_property(VCARD_TESTER_C_COMPILE_FLAGS vcard_tester.c COMPILE_FLAGS)
	set(VCARD_TESTER_C_COMPILE_FLAGS "${VCARD_TESTER_C_COMPILE_FLAGS} /wd4996") # Disable "was declared deprecated" warnings
	set_source_files_properties(vcard_tester.c PROPERTY COMPILE_FLAGS "${VCARD_TESTER_C_COMPILE_FLAGS}")
endif()

if(NOT IOS OR NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
	# Executable must be available on root path, not host one

=== tools/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

set(USE_BUNDLE )
if(IOS)
	set(USE_BUNDLE MACOSX_BUNDLE)
endif()

set(LP_AUTO_ANSWER_SOURCE_FILES	auto_answer.c)
bc_apply_compile_flags(LP_AUTO_ANSWER_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
add_executable(liblinphone-auto-answer ${USE_BUNDLE} ${LP_AUTO_ANSWER_SOURCE_FILES})
target_link_libraries(liblinphone-auto-answer PRIVATE ${LINPHONE_LIBS_FOR_TOOLS} ${Mediastreamer2_TARGET} ${Ortp_TARGET} ${BCToolbox_TARGET} ${XSD_LIBRARIES})
set_target_properties(liblinphone-auto-answer PROPERTIES LINKER_LANGUAGE CXX)

set(LP_SENDMSG_SOURCE_FILES lpsendmsg.c)
bc_apply_compile_flags(LP_SENDMSG_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
add_executable(liblinphone-sendmsg ${USE_BUNDLE} ${LP_SENDMSG_SOURCE_FILES})
target_link_libraries(liblinphone-sendmsg PRIVATE ${LINPHONE_LIBS_FOR_TOOLS} ${Mediastreamer2_TARGET} ${Ortp_TARGET} ${XSD_LIBRARIES})
set_target_properties(liblinphone-sendmsg PROPERTIES LINKER_LANGUAGE CXX)

if(ENABLE_XML2)
	set(LP_LPC2XML_TEST_SOURCE_FILES lpc2xml_test.c)
	bc_apply_compile_flags(LP_LPC2XML_TEST_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
	add_executable(liblinphone-lpc2xml-test ${USE_BUNDLE} ${LP_LPC2XML_TEST_SOURCE_FILES})
	target_link_libraries(liblinphone-lpc2xml-test PRIVATE ${LINPHONE_LIBS_FOR_TOOLS} ${Mediastreamer2_TARGET} ${Ortp_TARGET} ${XSD_LIBRARIES})
	set_target_properties(liblinphone-lpc2xml-test PROPERTIES LINKER_LANGUAGE CXX)

	set(LP_XML2LPC_TEST_SOURCE_FILES xml2lpc_test.c)
	bc_apply_compile_flags(LP_XML2LPC_TEST_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
	add_executable(liblinphone-xml2lpc-test ${USE_BUNDLE} ${LP_XML2LPC_TEST_SOURCE_FILES})
	target_link_libraries(liblinphone-xml2lpc-test PRIVATE ${LINPHONE_LIBS_FOR_TOOLS} ${Mediastreamer2_TARGET} ${Ortp_TARGET} ${XSD_LIBRARIES})
	set_target_properties(liblinphone-xml2lpc-test PROPERTIES LINKER_LANGUAGE CXX)

	set(LINPHONE_XMLTOOLS liblinphone-lpc2xml-test liblinphone-xml2lpc-test)
endif()

set(LP_TEST_ECC_SOURCE_FILES test_ecc.c)
bc_apply_compile_flags(LP_TEST_ECC_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
add_executable(liblinphone-test-ecc ${USE_BUNDLE} ${LP_TEST_ECC_SOURCE_FILES})
target_link_libraries(liblinphone-test-ecc PRIVATE ${LINPHONE_LIBS_FOR_TOOLS} ${Mediastreamer2_TARGET} ${Ortp_TARGET} ${BCToolbox_TARGET} ${XSD_LIBRARIES})
set_target_properties(liblinphone-test-ecc PROPERTIES LINKER_LANGUAGE CXX)

if(NOT IOS)
	install(TARGETS liblinphone-auto-answer liblinphone-sendmsg liblinphone-test-ecc ${LINPHONE_XMLTOOLS}
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()

=== coreapi/help/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

add_subdirectory(examples/C)
add_subdirectory(doc)

=== plugins/example/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

cmake_minimum_required(VERSION 3.22)
project(exampleplugin VERSION 1.1.1 LANGUAGES C CXX)

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib/liblinphone/plugins")

set(PACKAGE "${PROJECT_NAME}")
set(PACKAGE_NAME "${PROJECT_NAME}")
set(PACKAGE_VERSION "${PROJECT_VERSION}")
set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set(PACKAGE_BUGREPORT "support@belledonne-communications.com")
set(PACKAGE_TARNAME "exampleplugin")
set(PACKAGE_URL "")
set(VERSION "${PACKAGE_VERSION}")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_EXTENSIONS NO)

include(GNUInstallDirs)

if(NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
endif()

find_library(LIBM NAMES m)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake" "${CMAKE_CURRENT_BINARY_DIR}/config.h")
set_source_files_properties("${CMAKE_CURRENT_BINARY_DIR}/config.h" PROPERTIES GENERATED ON)
add_definitions(-DHAVE_CONFIG_H)

set(SOURCE_FILES
	exampleplugin.cpp
)

set(INCLUDE_DIRS )
set(LIBS )

if(LIBM)
	list(APPEND LIBS ${LIBM})
endif()

if(BUILD_SHARED_LIBS)
	if(NOT IOS)
		add_library(exampleplugin MODULE ${SOURCE_FILES})
	else()
		add_library(exampleplugin SHARED ${SOURCE_FILES})
	endif()
else()
	add_library(exampleplugin STATIC ${SOURCE_FILES})
endif()

target_include_directories(exampleplugin PUBLIC
	$<INSTALL_INTERFACE:include/>
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/coreapi/>
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/>
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/>
	PRIVATE ${INCLUDE_DIRS}
)
target_link_libraries(exampleplugin PRIVATE liblinphone ${LIBS})
set_target_properties(exampleplugin PROPERTIES LINKER_LANGUAGE CXX)
if(APPLE)
	if(IOS)
		set(MIN_OS ${LINPHONE_IOS_DEPLOYMENT_TARGET})
		set_target_properties(exampleplugin PROPERTIES
			FRAMEWORK TRUE
			MACOSX_FRAMEWORK_IDENTIFIER org.linphone.exampleplugin
			MACOSX_FRAMEWORK_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in"
		)
	else()
		set(MIN_OS ${CMAKE_OSX_DEPLOYMENT_TARGET})
	endif()
endif()
if(MSVC)
	if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
		install(FILES $<TARGET_PDB_FILE:exampleplugin>
			DESTINATION ${CMAKE_INSTALL_BINDIR}
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
		)
	endif()
	if(NOT IOS)
		set_target_properties(exampleplugin PROPERTIES PREFIX "lib")
	endif()
endif()

install(TARGETS exampleplugin
		RUNTIME DESTINATION ${LIBLINPHONE_PLUGINS_DIR}
		LIBRARY DESTINATION ${LIBLINPHONE_PLUGINS_DIR}
		ARCHIVE DESTINATION ${LIBLINPHONE_PLUGINS_DIR}
		FRAMEWORK DESTINATION Frameworks
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== share/rings/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

set(RING_FILES
	"${CMAKE_CURRENT_SOURCE_DIR}/oldphone-mono.wav"
	"${CMAKE_CURRENT_SOURCE_DIR}/four_hands_together.mkv"
	"${CMAKE_CURRENT_SOURCE_DIR}/house_keeping.mkv"
	"${CMAKE_CURRENT_SOURCE_DIR}/its_a_game.mkv"
	"${CMAKE_CURRENT_SOURCE_DIR}/leaving_dreams.mkv"
	"${CMAKE_CURRENT_SOURCE_DIR}/notes_of_the_optimistic.mkv"
	"${CMAKE_CURRENT_SOURCE_DIR}/soft_as_snow.mkv"
	PARENT_SCOPE
)

=== wrappers/cpp/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
############################################################################
#
# This file is part of Liblinphone 
# (see https://gitlab.linphone.org/BC/public/liblinphone).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/include/linphone++/linphone.hh" "${CMAKE_CURRENT_BINARY_DIR}/src/linphone++.cc"
	COMMAND ${CMAKE_COMMAND} -E remove_directory include
	COMMAND ${CMAKE_COMMAND} -E remove_directory src
	COMMAND ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/genwrapper.py" "${PROJECT_BINARY_DIR}/coreapi/help/doc/doxygen/xml"
	DEPENDS ${PROJECT_SOURCE_DIR}/tools/genapixml.py
	${PROJECT_SOURCE_DIR}/tools/metadoc.py
	${PROJECT_SOURCE_DIR}/tools/metaname.py
	${PROJECT_SOURCE_DIR}/tools/abstractapi.py
	genwrapper.py
	class_header.mustache
	class_impl.mustache
	enums_header.mustache
	main_header.mustache
	${PROJECT_BINARY_DIR}/coreapi/help/doc/doxygen/xml/index.xml
	liblinphone-doc
)
add_custom_target(liblinphone-cxx-wrapper ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/include/linphone++/linphone.hh" "${CMAKE_CURRENT_BINARY_DIR}/src/linphone++.cc")

add_library(liblinphone++
	object.cc
	tools.cc
	${CMAKE_CURRENT_BINARY_DIR}/src/linphone++.cc
)
add_dependencies(liblinphone++ liblinphone-cxx-wrapper)

if(APPLE)
	set_target_properties(liblinphone++ PROPERTIES OUTPUT_NAME linphone++)
else()
	set_target_properties(liblinphone++ PROPERTIES OUTPUT_NAME liblinphone++)
endif()
set_target_properties(liblinphone++ PROPERTIES PREFIX "")
if(MSVC)
    set_target_properties(liblinphone++ PROPERTIES PDB_NAME liblinphone++)
endif()
target_compile_definitions(liblinphone++ PRIVATE "-DLINPHONECXX_EXPORTS")
target_link_libraries(liblinphone++
	PRIVATE ${BCToolbox_TARGET} ${BelleSIP_TARGET} liblinphone
)

set_target_properties(liblinphone++ PROPERTIES
	FRAMEWORK TRUE
	MACOSX_FRAMEWORK_IDENTIFIER org.linphone.linphonecpp
	MACOSX_FRAMEWORK_INFO_PLIST "${PROJECT_SOURCE_DIR}/build/osx/Info.plist.in"
)

target_include_directories(liblinphone++
	PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
		$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
		$<INSTALL_INTERFACE:include>
	PRIVATE
		${PROJECT_BINARY_DIR}/include
)
set_target_properties(liblinphone++ PROPERTIES SOVERSION ${LINPHONE_SO_VERSION})

install(TARGETS liblinphone++ EXPORT LinphoneCxxTargets
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	FRAMEWORK DESTINATION Frameworks
)
install(FILES object.hh
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/linphone++
)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include/linphone++
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/LinphoneCxxVersion.cmake"
	VERSION ${PROJECT_VERSION}
	COMPATIBILITY AnyNewerVersion
)
configure_file(LinphoneCxxConfig.cmake.in LinphoneCxxConfig.cmake @ONLY)

install(EXPORT LinphoneCxxTargets
	FILE LinphoneCxxTargets.cmake
	DESTINATION "${CMAKE_INSTALL_DATADIR}/LinphoneCxx/cmake"
)
install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/LinphoneCxxConfig.cmake"
	"${CMAKE_CURRENT_BINARY_DIR}/LinphoneCxxVersion.cmake"
	DESTINATION "${CMAKE_INSTALL_DATADIR}/LinphoneCxx/cmake"
)

if(ENABLE_DOC OR ENABLE_CXX_WRAPPER)
	find_package(Doxygen REQUIRED)
	if(DOXYGEN_FOUND)
		set(top_srcdir "${PROJECT_SOURCE_DIR}")

		# Remove everything after the last point in LINPHONE_VERSION (4.5.0 --> 4.5) to create STRIPPED_LINPHONE_VERSION
		string(REGEX REPLACE "\\.[^.]*$" "" STRIPPED_LINPHONE_VERSION ${LINPHONE_VERSION})
		# Replace @LINPHONESDK_STATE@ and @STRIPPED_LINPHONE_VERSION@ in site main page
		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doxygen.dox.in ${CMAKE_CURRENT_BINARY_DIR}/doxygen.dox)

		set(DOXYGEN_INPUT "")
		string(CONCAT DOXYGEN_INPUT ${DOXYGEN_INPUT} " \"${CMAKE_CURRENT_BINARY_DIR}/include/linphone++\"")
		string(CONCAT DOXYGEN_INPUT ${DOXYGEN_INPUT} " \"${CMAKE_CURRENT_BINARY_DIR}/doxygen.dox\"")

		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
		set(DOC_INPUT_FILES ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
			${CMAKE_CURRENT_BINARY_DIR}/doxygen.dox
		)

		set(CPP_HTML_DIR "${CMAKE_CURRENT_BINARY_DIR}/cpp")
		set(LINPHONE_DOXYGEN_CPP_HTML_DIR ${CPP_HTML_DIR} PARENT_SCOPE)
		add_custom_command(OUTPUT "${CPP_HTML_DIR}/index.html"
			COMMAND ${CMAKE_COMMAND} -E remove -f ${CPP_HTML_DIR}/*
			COMMAND ${CMAKE_COMMAND} -E make_directory ${CPP_HTML_DIR}
			COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
			DEPENDS ${DOC_INPUT_FILES}
			liblinphone-cxx-wrapper
		)
		add_custom_target(linphone-cpp-html-doc ALL DEPENDS "${CPP_HTML_DIR}/index.html")
		if(ENABLE_DOC)
			install(DIRECTORY "${CPP_HTML_DIR}"
				DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/liblinphone-${LINPHONE_VERSION}")
		endif()
	endif()
endif()

=== debian/changelog ===
linphone (5.3.105-6ubuntu2) questing; urgency=medium

  * Stick with O2 on ppc64el to fix gcc build failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 29 Aug 2025 09:43:19 +0200

linphone (5.3.105-6) unstable; urgency=medium

  * Team upload

  [ Matthias Klose ]
  * Fix build with libxml 2.14.x

 -- Bastian Germann <bage@debian.org>  Fri, 22 Aug 2025 09:36:35 +0200

linphone (5.3.105-5) unstable; urgency=medium

  * Team upload
  * Add Depends referenced by .pc file

 -- Bastian Germann <bage@debian.org>  Fri, 21 Mar 2025 21:16:07 +0100

linphone (5.3.105-4) unstable; urgency=medium

  * Team upload
  * Disable FlexiAPI because libjsoncpp has wrong libname

 -- Bastian Germann <bage@debian.org>  Tue, 04 Mar 2025 22:04:32 +0100

linphone (5.3.105-3) unstable; urgency=medium

  * Team upload
  * Add directory referenced in .cmake

 -- Bastian Germann <bage@debian.org>  Tue, 04 Mar 2025 18:31:01 +0100

linphone (5.3.105-2) unstable; urgency=medium

  * Team upload
  * Drop shlibs.local

  [ Daniel Kahn Gillmor ]
  * Actually require LINPHONE_DO_APPIMAGE_DOWNLOAD=y for AppImage download

 -- Bastian Germann <bage@debian.org>  Mon, 03 Mar 2025 13:23:16 +0100

linphone (5.3.105-1) unstable; urgency=medium

  * Team upload
  * New upstream version 5.3.105 (Closes: #1099181, #1094046)
  * Refresh copyright info
  * Refresh patches
  * Move from custom ENABLE_SHARED to BUILD_SHARED_LIBS
  * Build without readline patch

 -- Bastian Germann <bage@debian.org>  Sat, 01 Mar 2025 15:36:45 +0100

=== debian/control ===
Source: linphone
Section: sound
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Kilian Krause <kilian@debian.org>,
           Tzafrir Cohen <tzafrir@debian.org>,
           Felix Lechner <felix.lechner@gmail.com>,
           Bernhard Schmidt <berni@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
Build-Depends-Indep: graphviz,
Build-Depends-Arch: libbctoolbox-dev (>= 5.2.98~),
                    libbelcard-dev (>= 5.2.98~),
                    libbellesip-dev (>= 5.2.98~),
                    libbelr-dev (>= 5.2.98~),
                    libboost-dev,
# Ever since switching to LIME_X3DH liblinphone no longer links with brztp,
# but the build scripts were not reworked, so we still need this.
                    libbzrtp-dev (>= 5.2.98~),
                    libldap2-dev,
                    liblime-dev (>= 5.2.98~),
                    libmediastreamer-dev (>= 1:5.2.98+dfsg~),
                    libortp-dev (>= 1:5.2.98~),
                    libreadline-dev,
                    libsoci-dev (>= 4.0.1-4~),
                    libsqlite3-dev,
                    libturbojpeg0-dev,
                    libudev-dev,
                    libxerces-c-dev,
                    libzxing-dev,
                    python3-pystache,
                    python3-six,
                    xsdcxx,
                    zlib1g-dev,
Standards-Version: 4.6.2
Homepage: https://www.linphone.org/
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/linphone
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/linphone.git
Description: SIP softphone - core library

Package: liblinphone-dev
Section: libdevel
Depends: liblinphone12 (= ${binary:Version}),
         liblinphone++12 (= ${binary:Version}),
         libbelcard-dev (>= 5.2.98~),
         libbellesip-dev (>= 5.2.98~),
         libbelr-dev (>= 5.2.98~),
         liblime-dev,
         libmediastreamer-dev (>= 5.2.98~),
         libortp-dev (>= 5.2.98~),
         libsqlite3-dev,
         libxml2-dev,
         ${misc:Depends},
Architecture: any
Multi-Arch: same
Description: Linphone web phone's library - development files
 Linphone is an audio and video internet phone using the SIP protocol. It
 has a GTK+ and console interface, includes a large variety of audio and video
 codecs, and provides IM features.
 .
 This package contains the files needed to use the linphone's library in your
 programs.

Package: liblinphone12
Section: libs
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
# the identity_grammar file is needed to use certain features
         linphone-common (= ${source:Version}),
Architecture: any
Multi-Arch: same
Description: Linphone's shared library part (supporting the SIP protocol)
 Linphone is an audio and video internet phone using the SIP protocol. It
 has a GTK+ and console interface, includes a large variety of audio and video
 codecs, and provides IM features.
 .
 This package contains the shared runtime libraries.

Package: liblinphone++12
Section: libs
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Architecture: any
Multi-Arch: same
Description: Linphone's shared library part (supporting the SIP protocol)
 Linphone is an audio and video internet phone using the SIP protocol. It
 has a GTK+ and console interface, includes a large variety of audio and video
 codecs, and provides IM features.
 .
 This package contains the C++ shared runtime libraries.

Package: linphone-common
Depends: ${misc:Depends},
Architecture: all
Multi-Arch: foreign
Description: Shared components of the linphone SIP softphone
 Linphone is an audio and video internet phone using the SIP protocol. It
 has a GTK+ and console interface, includes a large variety of audio and video
 codecs, and provides IM features.
 .
 This package contains the resource files of linphone (the rings).

Package: linphone-cli
Depends: host,
         liblinphone12 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Replaces: linphone-nogtk (<< 4.4.0-2~)
Breaks: linphone-nogtk (<< 4.4.0-2~)
Suggests: espeak|espeak-ng-espeak,
Architecture: any
Description: SIP softphone - console-only client
 Linphone is an audio and video internet phone using the SIP protocol. It
 has a GTK+ and console interface, includes a large variety of audio and video
 codecs, and provides IM features.
 .
 This package contains the console version of linphone.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -I/usr/include/jsoncpp

include /usr/share/dpkg/pkg-info.mk

ifeq (ppc64el, $(DEB_HOST_ARCH))
export DEB_CFLAGS_MAINT_APPEND = -O2
export DEB_CFLAGS_MAINT_STRIP = -O3
export DEB_CXXFLAGS_MAINT_APPEND = -O2
export DEB_CXXFLAGS_MAINT_STRIP = -O3
endif

DEB_REQUESTED_PACKAGES := $(shell dh_listpackages)
when-in-build-profile     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-not-in-build-profile = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-building-package     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))
when-not-building-package = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))

# The macro bc_compute_lib_version (among others) from
# /usr/share/bctoolbox/cmake/bctoolboxCMakeUtils.cmake expects the
# .git directory to be available.  We fool it with a shellscript
# that returns the version from debian/changelog
options += -DGIT_EXECUTABLE=/usr/share/bctoolbox/upstream-version-from-changelog
options += -DDEB_VERSION_UPSTREAM=$(DEB_VERSION_UPSTREAM)

# The path resolution logic throughout linphone-stack is very confusing.
# Check with: strings debian/liblinphone??/usr/lib/*/liblinphone.so.*|grep share/
options += -DCMAKE_INSTALL_DATADIR="share/linphone"

export DEB_CFLAGS_MAINT_APPEND += -DPACKAGE_SOUND_DIR="\"/usr/share/sounds/linphone\""
       DEB_CFLAGS_MAINT_APPEND += -DPACKAGE_RING_DIR="\"/usr/share/sounds/linphone/rings\""
export DEB_CXXFLAGS_MAINT_APPEND := $(DEB_CFLAGS_MAINT_APPEND)

# Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
# setting CMAKE_SKIP_RPATH
options += -DCMAKE_SKIP_RPATH=ON

libpkgname := liblinphone12

# this enables the unified call+chat database; it requires sqlite3 and
# a version of libsoci-dev built with C++11 support
features += -DENABLE_DB_STORAGE=$(call when-building-package,$(libpkgname),YES,NO) # libsoci-dev

features += -DENABLE_ADVANCED_IM=$(call when-building-package,$(libpkgname),YES,NO) # libxerces-c-dev xsdcxx

features += -DENABLE_LDAP=$(call when-building-package,$(libpkgname),YES,NO) # libldap2-dev
features += -DENABLE_JPEG=$(call when-building-package,$(libpkgname),YES,NO) # libturbojpeg0-dev, libzxingcore-dev (>= 1.4.0~),

features += -DENABLE_CONSOLE_UI=ON
features += -DENABLE_FLEXIAPI=NO
features += -DENABLE_LIME=NO
features += -DENABLE_LIME_X3DH=$(call when-building-package,$(libpkgname),YES,NO) # liblime-dev
features += -DENABLE_UNIT_TESTS=NO
features += -DBUILD_SHARED_LIBS=ON

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	if ! [ -f debian/$(libpkgname).shlibs ]; then \
		echo "HINT: You must update d/rules to have the new soname!" | grep --color '^.*$$' >&2 ; \
		false ; \
	fi
ifeq (x,$(call when-building-package,$(libpkgname),x))
	dh_auto_configure -- \
		$(options) \
		$(features)
endif

override_dh_auto_test:

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

execute_after_dh_auto_build-arch:
#	false

override_dh_auto_install-arch:
	dh_auto_install

override_dh_auto_build-indep:
	true

override_dh_auto_build-arch:
# comment out these path macro definitions because fixing CMakeLists.txt is too much work
	sed -i '/^#define PACKAGE_SOUND_DIR/s@^@//@' obj-$(DEB_HOST_GNU_TYPE)/config.h
	sed -i '/^#define PACKAGE_RING_DIR/s@^@//@' obj-$(DEB_HOST_GNU_TYPE)/config.h
	dh_auto_build

override_dh_auto_install-indep:
	mkdir  -p debian/tmp/usr/share/belr/grammars
	cp    -at debian/tmp/usr/share/belr/grammars   share/*_grammar
	mkdir  -p debian/tmp/usr/share/linphone
	cp    -at debian/tmp/usr/share/linphone        share/rootca.pem
	mkdir  -p debian/tmp/usr/share/sounds/linphone
	cp    -at debian/tmp/usr/share/sounds/linphone share/*.wav share/*.mkv
	cp -R -at debian/tmp/usr/share/sounds/linphone share/rings

execute_before_dh_shlibdeps-arch:
	./debian/shlibs-watchdog ./debian

# shlibdeps generates a dependency to libsoci-core, but we actually need
# the sqlite3 interface implementation
execute_after_dh_shlibdeps-arch:
	sed -i s/libsoci-core/libsoci-sqlite3-/g debian/*.substvars

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/liblinphone.*\.tar\.gz/linphone-$1\.tar\.gz/g \
  https://gitlab.linphone.org/BC/public/liblinphone/tags?sort=updated_desc .*/archive/([\d\.]+)/.*\.tar\.gz.*
